    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ----------
    028 * Layer.java
    029 * ----------
    030 * (C) Copyright 2003, 2004, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * $Id: Layer.java,v 1.4 2005/10/18 13:18:34 mungady Exp $
    036 *
    037 * Changes:
    038 * --------
    039 * 17-Sep-2003 (DG);
    040 *
    041 */
    042
    043package org.jfree.ui;
    044
    045import java.io.ObjectStreamException;
    046import java.io.Serializable;
    047
    048/**
    049 * Used to indicate either the foreground or background layer.
    050 *
    051 * @author David Gilbert
    052 */
    053public final class Layer implements Serializable {
    054
    055    /** For serialization. */
    056    private static final long serialVersionUID = -1470104570733183430L;
    057
    058    /** Foreground. */
    059    public static final Layer FOREGROUND = new Layer("Layer.FOREGROUND");
    060
    061    /** Background. */
    062    public static final Layer BACKGROUND = new Layer("Layer.BACKGROUND");
    063
    064    /** The name. */
    065    private String name;
    066
    067    /**
    068     * Private constructor.
    069     *
    070     * @param name  the name.
    071     */
    072    private Layer(final String name) {
    073        this.name = name;
    074    }
    075
    076    /**
    077     * Returns a string representing the object.
    078     *
    079     * @return The string.
    080     */
    081    public String toString() {
    082        return this.name;
    083    }
    084
    085    /**
    086     * Returns <code>true</code> if this object is equal to the specified
    087     * object, and <code>false</code> otherwise.
    088     *
    089     * @param o  the other object.
    090     *
    091     * @return A boolean.
    092     */
    093    public boolean equals(final Object o) {
    094
    095        if (this == o) {
    096            return true;
    097        }
    098        if (!(o instanceof Layer)) {
    099            return false;
    100        }
    101
    102        final Layer layer = (Layer) o;
    103        if (!this.name.equals(layer.name)) {
    104            return false;
    105        }
    106
    107        return true;
    108
    109    }
    110
    111    /**
    112     * Returns a hash code value for the object.
    113     *
    114     * @return the hashcode
    115     */
    116    public int hashCode() {
    117        return this.name.hashCode();
    118    }
    119
    120    /**
    121     * Ensures that serialization returns the unique instances.
    122     *
    123     * @return The object.
    124     *
    125     * @throws ObjectStreamException if there is a problem.
    126     */
    127    private Object readResolve() throws ObjectStreamException {
    128        Layer result = null;
    129        if (this.equals(Layer.FOREGROUND)) {
    130            result = Layer.FOREGROUND;
    131        }
    132        else if (this.equals(Layer.BACKGROUND)) {
    133            result = Layer.BACKGROUND;
    134        }
    135        return result;
    136    }
    137
    138}
    139